// OpenGLView.cpp : implementation of the COpenGLView class

#include "stdafx.h"
#include "OpenGL.h"
#include "OpenGLDoc.h"
#include "DialogAdd.h"
#include "DialogClear.h"
#include "DialogColor.h"
#include "OpenGLDoc.h"
#include "OpenGLView.h"
#include "MainFrm.h""
#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

int p[4];
int dc[4];
bool E=FALSE;
double BoxColor[4]={0,1,0,1};
double TETColor[4]={0,0,1,1};
double SURColor[4]={1,0,0,1};
double BACKColor[4]={1,1,1,1};
float LIGHT[4]={0.5,0.5,0.5,1};
int LINEWIDTH[3]={3,3,3};
int FILLSTYLE[3]={GL_LINE,GL_LINE,GL_FILL};
/////////////////////////////////////////////////////////////////////////////
// COpenGLView

//vector<vector<vector<int> > > box;
//vector<int> box;
IMPLEMENT_DYNCREATE(COpenGLView, CView)

BEGIN_MESSAGE_MAP(COpenGLView, CView)
	//{{AFX_MSG_MAP(COpenGLView)
	ON_WM_CREATE()
	ON_WM_DESTROY()
	ON_WM_SIZE()
	ON_COMMAND(ID_EDIT_E, OnEditE)
	ON_COMMAND(ID_SURF, OnSurf)
	ON_COMMAND(ID_Clear, OnClear)
	ON_COMMAND(ID_Color, OnColor)
	ON_COMMAND(ID_Lines, OnLines)
	ON_COMMAND(ID_Fill, OnFill)
	ON_WM_MOUSEMOVE()
	ON_WM_LBUTTONDOWN()
	ON_WM_LBUTTONUP()
	ON_WM_TIMER()
	ON_WM_KEYUP()
	ON_WM_KEYDOWN()
	ON_COMMAND(ID_Light, OnLight)
	ON_COMMAND(ID_TOOL_ADD, OnToolAdd)
	ON_COMMAND(ID_TOOL_DEL, OnToolDel)
	ON_COMMAND(ID_TOOL_COL, OnToolCol)
	ON_COMMAND(ID_TOL_LIN, OnTolLin)
	ON_COMMAND(ID_TOL_FIL, OnTolFil)
	ON_COMMAND(ID_TOL_LIG, OnTolLig)
	ON_COMMAND(ID_SCAL_MIN, OnScalMin)
	ON_COMMAND(ID_FILE_OPEN, OnFileOpen)
	ON_COMMAND(ID_FILE_SAVE, OnFileSave)
	ON_COMMAND(ID_FILE_SAVE_AS, OnFileSaveAs)
	ON_WM_SHOWWINDOW()
	ON_COMMAND(ID_SCAL_DEF, OnScalDef)
	ON_COMMAND(ID_SCAL_MAX, OnScalMax)
	//}}AFX_MSG_MAP
	// Standard printing commands
	ON_COMMAND(ID_FILE_PRINT, CView::OnFilePrint)
	ON_COMMAND(ID_FILE_PRINT_DIRECT, CView::OnFilePrint)
	ON_COMMAND(ID_FILE_PRINT_PREVIEW, CView::OnFilePrintPreview)
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// COpenGLView construction/destruction

COpenGLView::COpenGLView()
{
	// TODO: add construction code here
    m_xRotate = 0;
	m_yRotate = 0;
	m_xMove=0;
	m_yMove=0;

	m_Rotate = FALSE;
    m_Scale = 1.0f;
	
	
	m_LeftButtonDown = FALSE;
    m_ShiftKeyDown=FALSE;
}

COpenGLView::~COpenGLView()
{
}

BOOL COpenGLView::PreCreateWindow(CREATESTRUCT& cs)
{
	cs.style |= (WS_CLIPCHILDREN | WS_CLIPSIBLINGS);
	return CView::PreCreateWindow(cs);
}

/////////////////////////////////////////////////////////////////////////////
// COpenGLView drawing

void COpenGLView::OnDraw(CDC* pDC)
{
	COpenGLDoc* pDoc = GetDocument();
	ASSERT_VALID(pDoc);
	// TODO: add draw code for native data here
}

/////////////////////////////////////////////////////////////////////////////
// COpenGLView printing

BOOL COpenGLView::OnPreparePrinting(CPrintInfo* pInfo)
{
	// default preparation
	return DoPreparePrinting(pInfo);
}

void COpenGLView::OnBeginPrinting(CDC* /*pDC*/, CPrintInfo* /*pInfo*/)
{
	// TODO: add extra initialization before printing
}

void COpenGLView::OnEndPrinting(CDC* /*pDC*/, CPrintInfo* /*pInfo*/)
{
	// TODO: add cleanup after printing
}

/////////////////////////////////////////////////////////////////////////////
// COpenGLView diagnostics

#ifdef _DEBUG
void COpenGLView::AssertValid() const
{
	CView::AssertValid();
}

void COpenGLView::Dump(CDumpContext& dc) const
{
	CView::Dump(dc);
}

COpenGLDoc* COpenGLView::GetDocument() // non-debug version is inline
{
	ASSERT(m_pDocument->IsKindOf(RUNTIME_CLASS(COpenGLDoc)));
	return (COpenGLDoc*)m_pDocument;
}
#endif //_DEBUG

/////////////////////////////////////////////////////////////////////////////
// COpenGLView message handlers

int COpenGLView::SetWindowPixelFormat(HDC hDC)
{
int m_GLPixelIndex;
PIXELFORMATDESCRIPTOR pfd;
pfd.nSize = sizeof (PIXELFORMATDESCRIPTOR);
pfd.nVersion = 1;
pfd.dwFlags = PFD_DRAW_TO_WINDOW | PFD_SUPPORT_OPENGL | PFD_DOUBLEBUFFER;
pfd.iPixelType = PFD_TYPE_RGBA;
pfd.cColorBits = 32;
pfd.cRedBits = 8;
pfd.cRedShift = 16;
pfd.cGreenBits = 8;
pfd.cGreenShift = 8;
pfd.cBlueBits = 8;
pfd.cBlueShift = 0;
pfd.cAlphaBits = 0;
pfd.cAlphaShift = 0;
pfd.cAccumBits = 64;
pfd.cAccumRedBits = 16;
pfd.cAccumGreenBits = 16;
pfd.cAccumBlueBits = 16;
pfd.cAccumAlphaBits = 0;
pfd.cDepthBits = 32;
pfd.cStencilBits = 8;
pfd.cAuxBuffers = 0;
pfd.iLayerType = PFD_MAIN_PLANE;
pfd.bReserved = 0;
pfd.dwLayerMask = 0;
pfd.dwVisibleMask = 0;
pfd.dwDamageMask = 0;
m_GLPixelIndex = ChoosePixelFormat (hDC,&pfd);
if (m_GLPixelIndex==0)
{
m_GLPixelIndex=1;
if (DescribePixelFormat(hDC,m_GLPixelIndex,sizeof(PIXELFORMATDESCRIPTOR),&pfd)==0)
return 0;
}
if (SetPixelFormat (hDC,m_GLPixelIndex,&pfd)==FALSE)
return 0;
return 1;
}

void DialogAdd::OnLongSlider(NMHDR* pNMHDR, LRESULT* pResult) 
{
	UpdateData();
	p[1]=Long;
 	*pResult = 0;
}

void DialogAdd::OnWeightSlider2(NMHDR* pNMHDR, LRESULT* pResult) 
{
	UpdateData();
	p[3]=Weight;
	*pResult = 0;
}

void DialogAdd::OnHeightSlider3(NMHDR* pNMHDR, LRESULT* pResult) 
{
	UpdateData();
	p[2]=Height;
	*pResult = 0;
}

void DialogAdd::OnDXSlider4(NMHDR* pNMHDR, LRESULT* pResult) 
{
    UpdateData();
	dc[1]=dx;
	*pResult = 0;
}

void DialogAdd::OnDYSlider5(NMHDR* pNMHDR, LRESULT* pResult) 
{
	UpdateData();
	dc[2]=dy;
	*pResult = 0;
}

void DialogAdd::OnDZSlider6(NMHDR* pNMHDR, LRESULT* pResult) 
{
	UpdateData();
	dc[3]=dz;
	*pResult = 0;
}


void DialogColor::OnRedSlider1(NMHDR* pNMHDR, LRESULT* pResult) 
{
	UpdateData();
	switch(ColObj)
	{
	case 0:BoxColor[0]=Conv(Red);break;
	case 1:TETColor[0]=Conv(Red);break;
	case 2:SURColor[0]=Conv(Red);break;
	case 3:BACKColor[0]=Conv(Red);break;
	}
	*pResult = 0;
}

void DialogColor::OnGreenSlider2(NMHDR* pNMHDR, LRESULT* pResult) 
{
	UpdateData();
	switch(ColObj)
	{
	case 0:BoxColor[1]=Conv(Green);break;
	case 1:TETColor[1]=Conv(Green);break;
	case 2:SURColor[1]=Conv(Green);break;
	case 3:BACKColor[1]=Conv(Green);break;
	}
	*pResult = 0;

	
	*pResult = 0;
}

void DialogColor::OnBlueSlider3(NMHDR* pNMHDR, LRESULT* pResult) 
{
	UpdateData();
	switch(ColObj)
	{
	case 0:BoxColor[2]=Conv(Blue);break;
	case 1:TETColor[2]=Conv(Blue);break;
	case 2:SURColor[2]=Conv(Blue);break;
	case 3:BACKColor[2]=Conv(Blue);break;
	}
	*pResult = 0;
}

void DialogColor::OnAlphaSlider5(NMHDR* pNMHDR, LRESULT* pResult) 
{
	UpdateData();
	switch(ColObj)
	{
	case 0:BoxColor[3]=Conv(Alpha);break;
	case 1:TETColor[3]=Conv(Alpha);break;
	case 2:SURColor[3]=Conv(Alpha);break;
	case 3:BACKColor[3]=Conv(Alpha);break;
	}
	*pResult = 0;
}


void DialogColor::OnDefault() 
{
UpdateData();
	switch(ColObj)
	{
	case 0:
		BoxColor[0]=0;
		BoxColor[1]=1;
		BoxColor[2]=0;
		BoxColor[3]=1;
		c_red.SetPos(0);
		c_green.SetPos(-1000);
		c_blue.SetPos(0);
		c_alpha.SetPos(-1000);
		UpdateData();
		break;
	case 1:
		TETColor[0]=0;
		TETColor[1]=0;
		TETColor[2]=1;
		TETColor[3]=1;
		c_red.SetPos(0);
		c_green.SetPos(0);
		c_blue.SetPos(-1000);
		c_alpha.SetPos(-1000);	
		UpdateData();
		break;
	case 2:
		SURColor[0]=1;
		SURColor[1]=0;
		SURColor[2]=0;
		SURColor[3]=1;
		c_red.SetPos(-1000);
		c_green.SetPos(0);
		c_blue.SetPos(0);
		c_alpha.SetPos(-1000);	
		UpdateData();
		break;
	case 3:
		BACKColor[0]=1;
		BACKColor[1]=1;
		BACKColor[2]=1;
		BACKColor[3]=1;
		c_red.SetPos(-1000);
		c_green.SetPos(-1000);
		c_blue.SetPos(-1000);
		c_alpha.SetPos(-1000);	
		UpdateData();
		break;
	}	
SoundWav("DEFAULT");	
}

void DialogLines::OnLineSlider1(NMHDR* pNMHDR, LRESULT* pResult) 
{
	UpdateData();
	switch(LineObj)
	{
	case 0:LINEWIDTH[0]=Line;break;
	case 1:LINEWIDTH[1]=Line;break;
	case 2:LINEWIDTH[2]=Line;break;
	}
	*pResult = 0;
}

void DialogLines::OnDefault2() 
{
UpdateData();
switch(LineObj)
{
case 0:
	LINEWIDTH[0]=3;
	c_Line.SetPos(3);
	UpdateData();
	break;
case 1:
	LINEWIDTH[1]=3;
	c_Line.SetPos(3);
	UpdateData();
	break;
case 2:
	LINEWIDTH[2]=3;
	c_Line.SetPos(3);
	UpdateData();
	break;
}
SoundWav("DEFAULT");
}

void DialogFill::OnFillSlider1(NMHDR* pNMHDR, LRESULT* pResult) 
{
	UpdateData();
	switch(FillObj)
	{
	case 0:FILLSTYLE[0]=6911+Fill;break;
	case 1:FILLSTYLE[1]=6911+Fill;break;
	case 2:FILLSTYLE[2]=6911+Fill;break;
	}
	*pResult = 0;
}

void DialogFill::OnDefault3() 
{
UpdateData();	
switch(FillObj)
{
case 0:
	FILLSTYLE[0]=6913;
	c_fill.SetPos(2);
	UpdateData();
	break;
case 1:
	FILLSTYLE[1]=6913;
	c_fill.SetPos(2);
	UpdateData();
	break;
case 2:
	FILLSTYLE[2]=6914;
	c_fill.SetPos(3);
	UpdateData();
	break;
}
SoundWav("DEFAULT");
}

void DialogLight::OnLightSlider1(NMHDR* pNMHDR, LRESULT* pResult) 
{
    UpdateData();
	LIGHT[0]=-Conv(Light);
	LIGHT[1]=-Conv(Light);
	LIGHT[2]=-Conv(Light);
    *pResult = 0;
}

void DialogLight::OnDefault4() 
{
UpdateData();
c_light.SetPos(500);
LIGHT[0]=0.5;
LIGHT[1]=0.5;	
LIGHT[2]=0.5;	
SoundWav("DEFAULT");
}


// ""
void DialogAdd::OnButton1() 
{
UpdateData();
E=TRUE;
//  
if(Figure==-1)
{
	SoundWav("BITCH");
	MessageBox("   ,     !!! >:-(");
}
if(Figure==0&&(p[1]==0||p[2]==0||p[3]==0))
{ 
	SoundWav("BITCH");
    MessageBox("      !! ? >:-(");
}

//------------------------------
if(Figure==0)//	
{
int tmp[8][3];//    
// 1
dx=dx-p[1]/2;
dy=dy-p[2]/2;
dz=dz-p[3]/2;
tmp[0][0]=dx;
tmp[0][1]=dy;
tmp[0][2]=dz; 
// 2
tmp[1][0]=dx;
tmp[1][1]=dy+p[2];
tmp[1][2]=dz; 
// 3
tmp[2][0]=dx+p[1];
tmp[2][1]=dy+p[2];
tmp[2][2]=dz; 
// 4
tmp[3][0]=dx+p[1];
tmp[3][1]=dy;
tmp[3][2]=dz; 
// 5
tmp[4][0]=dx;
tmp[4][1]=dy;
tmp[4][2]=dz+p[3]; 
// 6
tmp[5][0]=dx;
tmp[5][1]=dy+p[2];
tmp[5][2]=dz+p[3]; 
// 7
tmp[6][0]=dx+p[1];
tmp[6][1]=dy+p[2];
tmp[6][2]=dz+p[3]; 
// 8
tmp[7][0]=dx+p[1];
tmp[7][1]=dy;
tmp[7][2]=dz+p[3]; 

//       
for (int i=0;i<=7;i++){
for (int j=0;j<=2;j++){
dot[j]=tmp[i][j];
}
DOT.push_back(dot);
}

//        
// 1-2-3-4
box.clear();
for (i=0;i<=2;i++){dot[i]=tmp[0][i];}
box.push_back(dot);
for (i=0;i<=2;i++){dot[i]=tmp[1][i];}
box.push_back(dot);
for (i=0;i<=2;i++){dot[i]=tmp[2][i];}
box.push_back(dot);
for (i=0;i<=2;i++){dot[i]=tmp[3][i];}
box.push_back(dot);
BOX.push_back(box);
box.clear();
// 5-6-7-8
for (i=0;i<=2;i++){dot[i]=tmp[4][i];}
box.push_back(dot);
for (i=0;i<=2;i++){dot[i]=tmp[5][i];}
box.push_back(dot);
for (i=0;i<=2;i++){dot[i]=tmp[6][i];}
box.push_back(dot);
for (i=0;i<=2;i++){dot[i]=tmp[7][i];}
box.push_back(dot);
BOX.push_back(box);
box.clear();
// 1-2-6-5
for (i=0;i<=2;i++){dot[i]=tmp[0][i];}
box.push_back(dot);
for (i=0;i<=2;i++){dot[i]=tmp[1][i];}
box.push_back(dot);
for (i=0;i<=2;i++){dot[i]=tmp[5][i];}
box.push_back(dot);
for (i=0;i<=2;i++){dot[i]=tmp[4][i];}
box.push_back(dot);
BOX.push_back(box);
box.clear();
// 4-3-7-8
for (i=0;i<=2;i++){dot[i]=tmp[3][i];}
box.push_back(dot);
for (i=0;i<=2;i++){dot[i]=tmp[2][i];}
box.push_back(dot);
for (i=0;i<=2;i++){dot[i]=tmp[6][i];}
box.push_back(dot);
for (i=0;i<=2;i++){dot[i]=tmp[7][i];}
box.push_back(dot);
BOX.push_back(box);
box.clear();
// 2-3-7-6
for (i=0;i<=2;i++){dot[i]=tmp[1][i];}
box.push_back(dot);
for (i=0;i<=2;i++){dot[i]=tmp[2][i];}
box.push_back(dot);
for (i=0;i<=2;i++){dot[i]=tmp[6][i];}
box.push_back(dot);
for (i=0;i<=2;i++){dot[i]=tmp[5][i];}
box.push_back(dot);
BOX.push_back(box);
box.clear();
// 1-4-8-5
for (i=0;i<=2;i++){dot[i]=tmp[0][i];}
box.push_back(dot);
for (i=0;i<=2;i++){dot[i]=tmp[3][i];}
box.push_back(dot);
for (i=0;i<=2;i++){dot[i]=tmp[7][i];}
box.push_back(dot);
for (i=0;i<=2;i++){dot[i]=tmp[4][i];}
box.push_back(dot);
BOX.push_back(box);
box.clear();
}

//------------------------------
if(Figure==1)//
{
int tmp[6][3];
int b;
b=sqrt(p[1]);
//1
tmp[0][0]=dx;tmp[0][1]=dy+b;tmp[0][2]=dz;
//2
tmp[1][0]=dx-b;tmp[1][1]=dy;tmp[1][2]=dz;
//3
tmp[2][0]=dx;tmp[2][1]=dy;tmp[2][2]=dz-b;
//4
tmp[3][0]=dx+b;tmp[3][1]=dy;tmp[3][2]=dz;
//5
tmp[4][0]=dx;tmp[4][1]=dy;tmp[4][2]=dz+b;
//6
tmp[5][0]=dx;tmp[5][1]=dy-b;tmp[5][2]=dz;

//       
for (int i=0;i<=5;i++){
for (int j=0;j<=2;j++){
dot[j]=tmp[i][j];
}
DOT.push_back(dot);
}

//        
// 1-2-3
tet.clear();
for (i=0;i<=2;i++){dot[i]=tmp[0][i];}
tet.push_back(dot);
for (i=0;i<=2;i++){dot[i]=tmp[1][i];}
tet.push_back(dot);
for (i=0;i<=2;i++){dot[i]=tmp[2][i];}
tet.push_back(dot);
TET.push_back(tet);
tet.clear();
// 1-3-4
for (i=0;i<=2;i++){dot[i]=tmp[0][i];}
tet.push_back(dot);
for (i=0;i<=2;i++){dot[i]=tmp[2][i];}
tet.push_back(dot);
for (i=0;i<=2;i++){dot[i]=tmp[3][i];}
tet.push_back(dot);
TET.push_back(tet);
tet.clear();
// 1-2-5
for (i=0;i<=2;i++){dot[i]=tmp[0][i];}
tet.push_back(dot);
for (i=0;i<=2;i++){dot[i]=tmp[1][i];}
tet.push_back(dot);
for (i=0;i<=2;i++){dot[i]=tmp[4][i];}
tet.push_back(dot);
TET.push_back(tet);
tet.clear();
// 1-5-4
for (i=0;i<=2;i++){dot[i]=tmp[0][i];}
tet.push_back(dot);
for (i=0;i<=2;i++){dot[i]=tmp[4][i];}
tet.push_back(dot);
for (i=0;i<=2;i++){dot[i]=tmp[3][i];}
tet.push_back(dot);
TET.push_back(tet);
tet.clear();
// 6-2-5
for (i=0;i<=2;i++){dot[i]=tmp[5][i];}
tet.push_back(dot);
for (i=0;i<=2;i++){dot[i]=tmp[1][i];}
tet.push_back(dot);
for (i=0;i<=2;i++){dot[i]=tmp[4][i];}
tet.push_back(dot);
TET.push_back(tet);
tet.clear();
// 6-2-3
for (i=0;i<=2;i++){dot[i]=tmp[5][i];}
tet.push_back(dot);
for (i=0;i<=2;i++){dot[i]=tmp[1][i];}
tet.push_back(dot);
for (i=0;i<=2;i++){dot[i]=tmp[2][i];}
tet.push_back(dot);
TET.push_back(tet);
tet.clear();
// 6-5-4
for (i=0;i<=2;i++){dot[i]=tmp[5][i];}
tet.push_back(dot);
for (i=0;i<=2;i++){dot[i]=tmp[4][i];}
tet.push_back(dot);
for (i=0;i<=2;i++){dot[i]=tmp[3][i];}
tet.push_back(dot);
TET.push_back(tet);
tet.clear();
// 6-4-3
for (i=0;i<=2;i++){dot[i]=tmp[5][i];}
tet.push_back(dot);
for (i=0;i<=2;i++){dot[i]=tmp[3][i];}
tet.push_back(dot);
for (i=0;i<=2;i++){dot[i]=tmp[2][i];}
tet.push_back(dot);
TET.push_back(tet);
tet.clear();
}
SoundWav("ADD");
}

void COpenGLView::OnSurf() 
{	
	TRI.clear();
	vector<int> D1(3,0);
	vector<int> D2(3,0);
	vector<int> D3(3,0);
	vector<int> D4(3,0);
	vector<vector<int> > tri;	
	vector<vector<int> >::iterator I1;
	vector<vector<int> >::iterator I2;
	vector<vector<int> >::iterator I3;
	vector<vector<int> >::iterator I4;
	int i=0,j=0,A,n=0,m=0,l=0;
	int a[4][4];
	
	if (E==FALSE)
	{
		SoundWav("SHIT");
		MessageBox("!   -   :-P");
	    SoundWav("HAHA");
		goto e1; 
	}
    SoundWav("GO!");
	for(I1=DOT.begin();I1!=DOT.end()-2;I1++)
	{
		i++;j=0;
		for(I2=DOT.begin()+i;I2!=DOT.end()-1;I2++)
		{
			j++;
			for(I3=DOT.begin()+i+j;I3!=DOT.end();I3++)
			{
				D1=*I1;
				D2=*I2;
				D3=*I3;
				n=0;m=0;
				for(I4=DOT.begin();I4!=DOT.end();I4++)
				{

					D4=*I4;
					// 
					a[1][1]=D2[0]-D1[0];
					a[1][2]=D2[1]-D1[1];
					a[1][3]=D2[2]-D1[2];
					// 
					a[2][1]=D3[0]-D1[0];
					a[2][2]=D3[1]-D1[1];
					a[2][3]=D3[2]-D1[2];
					// 
					a[3][1]=D1[0]-D4[0];
					a[3][2]=D1[1]-D4[1];
					a[3][3]=D1[2]-D4[2];
					//   
					A=a[1][1]*a[2][2]*a[3][3]+a[1][2]*a[2][3]*a[3][1]+a[1][3]*a[2][1]*a[3][2]-
					  a[1][3]*a[2][2]*a[3][1]-a[1][2]*a[2][1]*a[3][3]-a[1][1]*a[2][3]*a[3][2];
                    //  
					if(A>0){n++;}
					if(A<0){m++;}				
				}

				if(m==0||n==0)
				{
					tri.push_back(D1);
					tri.push_back(D2);
					tri.push_back(D3);
					TRI.push_back(tri);
					tri.clear();
				}			
			}
		}
	}	
SoundWav("COMPLETE");
e1:;
}


//-----=====[     ]=====-----
COpenGLView::display()
{
glClear( GL_COLOR_BUFFER_BIT | GL_DEPTH_BUFFER_BIT);
glClearColor(BACKColor[0],BACKColor[1],BACKColor[2],BACKColor[3]);
glLightModelfv(GL_LIGHT_MODEL_AMBIENT,LIGHT);
glPushMatrix();
glTranslated(0.0,0.0,-8.0);
glRotated(m_xRotate, 1.0, 0.0, 0.0);
glRotated(m_yRotate, 0.0, 1.0, 0.0);
glTranslated(m_xMove/40,0,0);
glTranslated(0,-m_yMove/20,0);
glScaled(m_Scale,m_Scale,m_Scale);
glColor4d(BoxColor[0],BoxColor[1],BoxColor[2],BoxColor[3]);
glPolygonMode(GL_FRONT_AND_BACK,FILLSTYLE[0]);
glLineWidth(LINEWIDTH[0]);glPointSize(LINEWIDTH[0]);
DrawBoxes(BOX);
glColor4d(TETColor[0],TETColor[1],TETColor[2],TETColor[3]);
glLineWidth(LINEWIDTH[1]);glPointSize(LINEWIDTH[1]);
glPolygonMode(GL_FRONT_AND_BACK,FILLSTYLE[1]);
DrawTetra(TET);
glColor4d(SURColor[0],SURColor[1],SURColor[2],SURColor[3]);
glLineWidth(LINEWIDTH[2]);glPointSize(LINEWIDTH[2]);
glPolygonMode(GL_FRONT_AND_BACK,FILLSTYLE[2]);
DrawSurface(TRI);
glPopMatrix();
glFinish();
SwapBuffers(wglGetCurrentDC());
}

int COpenGLView::OnCreate(LPCREATESTRUCT lpCreateStruct) 
{	
	if (CView::OnCreate(lpCreateStruct) == -1)
		return -1;
	
	pdc = new CClientDC(this);

	if (SetWindowPixelFormat(pdc->m_hDC)==FALSE)
	return -1;

	hGLRC = wglCreateContext(pdc->m_hDC);
if (hGLRC == NULL)
    return -1;

if (wglMakeCurrent (pdc->m_hDC,hGLRC)==FALSE)
return -1;

glEnable (GL_ALPHA_TEST);
glEnable (GL_DEPTH_TEST);
glEnable (GL_COLOR_MATERIAL);
glEnable (GL_LIGHTING);
glEnable (GL_LIGHT0);
glEnable (GL_BLEND);
glBlendFunc(GL_SRC_ALPHA, GL_ONE_MINUS_SRC_ALPHA);
float pos [4] = {3,3,3,1};
float dir [3] = {-1,-1,-1};
glLightfv(GL_LIGHT0,GL_POSITION,pos);
glLightfv(GL_LIGHT0,GL_SPOT_DIRECTION,dir);	
CenterWindow();
return 0;
}

void COpenGLView::OnDestroy() 
{
	if (wglGetCurrentContext()!=NULL)
		wglMakeCurrent(NULL,NULL);

	if (hGLRC!=NULL)
	{
		wglDeleteContext(hGLRC);
		hGLRC=NULL;
	}

	delete pdc;
	SoundWav("EXIT");
	CView::OnDestroy();
	
}

void COpenGLView::OnSize(UINT nType, int cx, int cy) 
{
	CView::OnSize(nType, cx, cy);	
	glViewport(0,10,cx,cy);
	glMatrixMode(GL_PROJECTION);
	glLoadIdentity();
	glOrtho(-8,8,-8,8,-120,120);
	glMatrixMode(GL_MODELVIEW);	
}

void COpenGLView::OnEditE() 
{
m_pDlg = new DialogAdd();
m_pDlg->Create(IDD_DIALOG1);	
SoundWav("MENU");
}

void COpenGLView::OnClear() 
{
m_pDlg2 = new DialogClear();
m_pDlg2->Create(IDD_DIALOG2);	
SoundWav("MENU");
}

void COpenGLView::OnColor() 
{
m_pDlg3= new DialogColor();
m_pDlg3->Create(IDD_DIALOG3);	
SoundWav("MENU");
}

void COpenGLView::OnLines() 
{
m_pDlg4= new DialogLines();
m_pDlg4->Create(IDD_DIALOG4);	
SoundWav("MENU");
}

void COpenGLView::OnFill() 
{
m_pDlg5=new DialogFill();
m_pDlg5->Create(IDD_DIALOG5);	
SoundWav("MENU");
}

void COpenGLView::OnLight() 
{
m_pDlg6=new DialogLight();
m_pDlg6->Create(IDD_DIALOG6);	
SoundWav("MENU");
}

void DialogClear::OnClearButton() 
{
	UpdateData();
	if (Object==0) {TRI.clear();};
	if (Object==1) {DOT.clear();BOX.clear();TET.clear();E=FALSE;}	
    SoundWav("DEL");
}

void COpenGLView::OnMouseMove(UINT nFlags, CPoint point) 
{
	if(m_LeftButtonDown==TRUE && m_ShiftKeyDown==FALSE)
	{
		CSize rotate = m_LeftDownPos - point;
		m_LeftDownPos = point;
		m_yRotate -= rotate.cx;
		m_xRotate -= rotate.cy;
		InvalidateRect(NULL,FALSE);
	}	
	if(m_LeftButtonDown==TRUE && m_ShiftKeyDown==TRUE)
    {
	    CSize move = m_LeftDownPos - point;
        m_LeftDownPos=point;
        m_yMove -= move.cy;
	    m_xMove -= move.cx;
	    InvalidateRect(NULL,FALSE);
	}
    

	CView::OnMouseMove(nFlags, point);

}

void COpenGLView::OnLButtonDown(UINT nFlags, CPoint point) 
{
	m_LeftButtonDown = TRUE;
	m_LeftDownPos = point;
	KillTimer(0);
	CView::OnLButtonDown(nFlags, point);
}

void COpenGLView::OnLButtonUp(UINT nFlags, CPoint point) 
{
	m_LeftButtonDown = FALSE;	
	CView::OnLButtonUp(nFlags, point);
}

void COpenGLView::Rotate()
{
    m_yRotate -= 2;
	InvalidateRect(NULL,FALSE);
}

void COpenGLView::OnTimer(UINT nIDEvent) 
{
	m_yRotate -= 3;
	m_xRotate -= 2;
	m_yMove-=1;
	m_xMove-=1;
	InvalidateRect(NULL,FALSE);
	CView::OnTimer(nIDEvent);
}

void COpenGLView::OnKeyUp(UINT nChar, UINT nRepCnt, UINT nFlags) 
{
	
	switch(nChar)
	{
	case 16:m_ShiftKeyDown=FALSE;break;
	}
	
	CView::OnKeyUp(nChar, nRepCnt, nFlags);
}

void COpenGLView::OnKeyDown(UINT nChar, UINT nRepCnt, UINT nFlags) 
{
    
	switch(nChar)
	{
	case 16:m_ShiftKeyDown=TRUE;break;
	case 187 :	m_Scale *= 1.1f;break;
	case 107 :	m_Scale *= 1.1f;break;
	case 189 :   m_Scale /= 1.1f;break;
	case 109 :   m_Scale /= 1.1f;break;
	case 8 :	m_Scale = 1.0f;break;
	case 106 :	m_Scale = 1.0f;break;
	}	
	CView::OnKeyDown(nChar, nRepCnt, nFlags);
}

void COpenGLDoc::Serialize(CArchive& ar)
{
	
	if (ar.IsStoring())
	{   
		 
	
	
	
	
	}
	else
	{
		
	}
}



void COpenGLView::OnToolAdd() 
{
m_pDlg = new DialogAdd();
m_pDlg->Create(IDD_DIALOG1);	
SoundWav("MENU");	
}

void COpenGLView::OnToolDel() 
{
m_pDlg2 = new DialogClear();
m_pDlg2->Create(IDD_DIALOG2);	
SoundWav("MENU");	
}

void COpenGLView::OnToolCol() 
{
m_pDlg3= new DialogColor();
m_pDlg3->Create(IDD_DIALOG3);	
SoundWav("MENU");	
}

void COpenGLView::OnTolLin() 
{
m_pDlg4= new DialogLines();
m_pDlg4->Create(IDD_DIALOG4);	
SoundWav("MENU");	
}

void COpenGLView::OnTolFil() 
{
m_pDlg5=new DialogFill();
m_pDlg5->Create(IDD_DIALOG5);	
SoundWav("MENU");	
}


void COpenGLView::OnTolLig() 
{
m_pDlg6=new DialogLight();
m_pDlg6->Create(IDD_DIALOG6);	
SoundWav("MENU");	
}

void COpenGLView::OnScalMax() 
{
m_Scale *= 1.1f;	
}

void COpenGLView::OnScalMin() 
{
m_Scale /= 1.1f;	
}

void COpenGLView::OnScalDef() 
{
m_Scale=1.0f;	
}

void COpenGLView::OnFileOpen() 
{
    SoundWav("SORRY");
	MessageBox("    ! :-\n       http:\\extrim.newmail.ru");
    SoundWav("HAHA2");
}

void COpenGLView::OnFileSave() 
{
	SoundWav("SORRY");
	MessageBox("    ! :-\n       http:\\extrim.newmail.ru");
    SoundWav("HAHA2");
	
}

void COpenGLView::OnFileSaveAs() 
{
	SoundWav("SORRY");
	MessageBox("    ! :-\n       http:\\extrim.newmail.ru");
    SoundWav("HAHA2");
	
}

void COpenGLView::OnShowWindow(BOOL bShow, UINT nStatus) 
{
	CView::OnShowWindow(bShow, nStatus);
	SoundWav("HEY");	
}

